<?php
/**
 * Thrive Themes - https://thrivethemes.com
 *
 * @package thrive-apprentice
 */

if ( ! defined( 'ABSPATH' ) ) {
	exit; // Silence is golden
}

$topics  = tva_get_topics( array( 'by_courses' => true ) );
$filters = array();
if ( isset( $_GET['filters'] ) && ! empty( $_GET['filters'] ) ) {
	$filter  = substr( $_GET['filters'], 0, - 1 );
	$filter  = substr( $filter, 1 );
	$filters = explode( ',', $filter );
}
$user_settings = TVA_Settings::instance();
$settings      = $user_settings->get_settings();
?>

<div class="tva-filters-wrapper">
	<div class="tva-filters-container">
		<?php if ( count( $topics ) > 1 ) : ?>
			<?php foreach ( $topics as $topic ) : ?>
				<div class="tva-filter-checkbox-container">
					<div class="tva-filter-checkbox-color-<?php echo $topic['ID']; ?> <?php echo in_array( $topic['ID'], $filters ) ? 'tva-filter-checkbox-selected' : ''; ?>"></div>
					<div class="tva-checkbox-holder">
						<img class="tva-filter-icon" src="<?php echo ! empty( $topic['icon'] ) ? $topic['icon'] : TVA_Const::get_default_course_icon_url(); ?>"/>
						<input type="checkbox" class="tva-filter tva-filter-course" name="tva-filter-course" <?php echo ( in_array( $topic['ID'], $arguments['topics'] ) || in_array( $topic['ID'], $filters ) ) ? 'checked="checked"' : ''; ?> id="tva-filter-course-<?php echo $topic['title']; ?>" value="<?php echo $topic['ID']; ?>">
						<label for="tva-filter-course-<?php echo $topic['title']; ?>">
							<?php echo $topic['title']; ?>
						</label>
					</div>
				</div>
			<?php endforeach; ?>

			<div class="tva-filter-checkbox-container tva-clear-filters">
				<span class="close-icon"></span>
				<input type="hidden" class="tva-filter tva-filter-course-clear-filters" id="tva-filter-course-clear-filters" value="">
				<label class="tva-filters-label" for="tva-filter-course-clear-filters">
					<?php echo __( 'Clear Filters', TVA_Const::T ); ?>
				</label>
			</div>
		<?php endif; ?>
	</div>

	<div class="tva-search-wrapper">
		<input id="tva_front_search" class="tva-search-input tva_search_text" type="text" onfocus="this.placeholder = ''" onblur="this.placeholder = '<?php echo $settings['template']['search_text']; ?>'" placeholder="<?php echo $settings['template']['search_text']; ?>">
		<a class="tva-search-submit" href="javascript:void(0)"></a>
	</div>
</div>
